﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ModbusDemo.MessageFormat;
namespace ModbusDemo.Modular
{
    class modual
    {
        public struct psx14p
        {
            public ushort[]  usX14pRegData;
            public ushort[]  usX14pRegType;
            public double[]  dX14pConvertData;
        }
        public class pcx14P
        {
            public byte[]                          byModbusID;
            public psx14p[]                        sX14pDataStruct;
            public ModbusComm.eModbusErrorCode[]   ModbusErrorCode;
            public pcx14P(byte[] InitIDlist)
            {
                this.byModbusID = InitIDlist; 
            }
        }
        public enum eX18xSensorChannelType : byte
        {
            Normal = 0,
            Level,
        }

        public struct psX18x
        {
            public ushort[]                     usRegData;
            public ushort[]                     usTypeData;
            public eX18xSensorChannelType[]     eChannelType;
            public double[]                     dConvertData;
        }
        public class pcx18X
        {
            public  byte[]                         byModbusID;
            public psX18x[]                        sX18xDataStruct;
            public ModbusComm.eModbusErrorCode[]   ModbusErrorCode;
            public pcx18X(byte[] InitIDlist, eX18xSensorChannelType[,] eChannnelType)
            {
                this.byModbusID         = InitIDlist;
                for (ushort i = 0; i < eChannnelType.GetLength(0); i++)
                {
                    for (ushort j = 0; j < eChannnelType.GetLength(1); j++)
                    {
                        this.sX18xDataStruct[i].eChannelType[j] = eChannnelType[i,j];
                    }
                }
            }
        }
        public struct psx78C
        {
            public bool[] bInputRegStatus;
            public bool[] bOutPutRegStatus;       
        }
        public class pcx78C
        {
            public byte[]                              byModbusID;
            public psx78C[]                            sx78CRegDataStructStatus;
            public ModbusComm.eModbusErrorCode[]       ModbusErrorCode;
            public pcx78C(byte[] InitIDlist)
            {
                this.byModbusID = InitIDlist;
            }
        }
        public struct psx66C
        {
            public bool[] bRegRelayStatus;
        }
        public class pcx66C
        {
            public byte[]                         byModbusID;
            public psx78C[]                        sx78CDatastructStatus;
            public ModbusComm.eModbusErrorCode[]   ModbusErrorCode;
            public pcx66C(byte[] InitIDlist)
            {
                this.byModbusID = InitIDlist;
            }
        }
    }
}
